#!/bin/sh
SERVER_NAME="server01.test.com"
DEST_SERVER_NAME="server02.test.com"
DEST_USER="backup"
LOCAL_TMP_DEST_DIR="/home/backup/archive/`date '+%Y%m%d'`"
#create the dir which contains the site backups
mkdir $LOCAL_TMP_DEST_DIR
# walk through all the user dirs
for FOLDER in /home/*; do
   if [ -d $FOLDER ]; then
      FILE_NAME="`basename $FOLDER`"
      if [ "$FILE_NAME" != "backup" ]; then
            # define the file name
            FILE_NAME_BACKUP="$FILE_NAME.tar.gz"
            # create the backup - exclude some dirs which we won't in the backup file
            tar -zcvpf $LOCAL_TMP_DEST_DIR/$FILE_NAME_BACKUP $FOLDER --exclude='/home/*/backups' --exclude='/home/*/domains/*/logs' --exclude='/home/*/domains/*/stats'
        fi
    fi
done

# first delete the remote backup files older then 7 days
ssh -i /home/backup/ssh_keys/${DEST_SERVER_NAME}.ppk $DEST_USER@$DEST_SERVER_NAME 'find /home/backup/archive/* -type d -mtime +7 -exec rm -rf {} \;'
# transfer the jar file to the external server
scp -r -i /home/backup/ssh_keys/${DEST_SERVER_NAME}.ppk $LOCAL_TMP_DEST_DIR $DEST_USER@$DEST_SERVER_NAME:/home/backup/archive/
# remove the local saved backup dir
rm -fr $LOCAL_TMP_DEST_DIR

