#!/bin/dash
# POSIX complaince
#	See: https://wiki.ubuntu.com/DashAsBinSh
#	     http://www.opengroup.org/onlinepubs/009695399/nfindex.html


# Asks a yes or no question
# $1 = the text to prompt
# $2 = the default answer of the prompt
# return 0 on YES, 1 on NO
#
# Example:
#   yesno "My question?" "no"
#   echo "Answer: $?"
yesno () {
	#The read in dash, which is used by Ubuntu, doesn't support the timeout function
	#so to make it compatible, I'll leave the timeout function out of this
	#for enabling the timeout function, add -t 10 to the read function

	ANSWER="invalid"
	DEFAULTANSWER="$2"
	
	while 	[ "$ANSWER" != "y" ] && 
		[ "$ANSWER" != "yes" ] &&
		[ "$ANSWER" != "n" ] &&
		[ "$ANSWER" != "no" ] &&
		[ "$ANSWER" != "" ]; 
	do
		if [ "$ANSWER" = "?" ]; then
			echo "  * Please answer YES or NO"
		fi
		read -p "  $1 (yes/y/no/n/?)    [$2]: " ANSWER

		ANSWER=`echo "$ANSWER" | tr '[:upper:]' '[:lower:]'`
	done

	if [ "$ANSWER" = "y" ]; then
		return 0
	fi
	
	if [ "$ANSWER" = "n" ] || [ "$ANSWER" = "no" ]; then
		return 1
	fi

	if [ "$DEFAULTANSWER" = "y" ] || [ "$ANSWER" = "yes" ]; then
		return 0
	fi
	
	return 1
}

yesno "My question?" "no"
echo "Answer: $?"
