#!/bin/sh
# installs the edubuntu-desktop on the client

#The fdisk script to run on the harddrive
FDISKSCRIPT="
n
p
1

+5000M
n
p
2


t
1
82
a
2
w
"

#The exclude list, used by rsync to copy the data on the harddrive of the thin client
COPYEXCLUDELIST="
/proc
/sys
/cow
/rofs
"

#The scripts to install
INSTALLSCRIPTS="edubuntu-desktop 
"

CHROOTCOMMANDS="
apt-get update > /dev/null 2>&1
dpkg-reconfigure -p low locales

source /root/.bashrc


"

DEBOOTSTRAPMIRROR="http://archive.ubuntu.com/ubuntu/"

HDDLIST="sda hda sdb hdb sdc hdc"
INSTALLDISK=""

for HDD in $HDDLIST; do
	echo $HDD
	if [ -e "/dev/$HDD" ]; then
		INSTALLDISK="/dev/$HDD"
	fi
done

if [ -z "$INSTALLDISK" ]; then
	exit 1;
fi

echo "Installing LTSP offline client on: $INSTALLDISK"
echo ""
exit;
aptitude update > /dev/null 2>&1
aptitude -y --force-yes install debootstrap rsync

TMPFILE=`tempfile`
TMPFILE2=`tempfile`

#check if there is no first partition (so disk is empty)
if [  -e "${INSTALLDISK}1" ]; then
	#clear partition table
	echo "\t* Clearing partition table of $INSTALLDISK"
	#dd if=/dev/zero of=/dev/sda bs=1M count=1024
	echo "$FDISKSCRIPT" > $TMPFILE
	echo "$COPYEXCLUDELIST" > $TMPFILE2

	echo "\t* Partitioning $INSTALLDISK"
	#fdisk /dev/sda < $TMPFILE

	#partprobe > /dev/null 2>&1

	echo "\t* Building filesystems on $INSTALLDISK"
	#mkswap "${INSTALLDISK}1"
	#mkfs.ext4 "${INSTALLDISK}2"

	#aptitude update > /dev/null 2>&1
	#aptitude -f install rsync

	echo "\t* Mounting ${INSTALLDISK}2 on /target"
	#mkdir /target
	#mount -t ext4 "${INSTALLDISK}2" /target

	#rsync -aHAX --exclude-from=$TMPFILE2 --delete / /target

	echo "\t* Debootstrapping chroot ${INSTALLDISK}2"
	debootstrap karmic /target $DEBOOTSTRAPMIRROR
	mount --bind /dev /target/dev
	mount -t proc proc /target/proc
	mount -t sysfs none /target/sys

	cp /etc/apt/sources.list /target/etc/apt/

	echo "#!/bin/sh" > /target/install-chroot.sh
	echo "$CHROOTCOMMANDS" >> /target/install-chroot.sh
	echo "exit" > /target/install-chroot.sh
	chmod a+rx > /target/install-chroot.sh

	chroot /target /target/install-chroot.sh

	echo "\t* Unmounting chroot ${INSTALLDISK}2"
	umount -f /target/proc
	umount -f /target/dev
	umount -f /target/sys
	umount -f /target

	swapon -a

	rm -f $TMPFILE $TMPFILE2
fi
